/// <reference types="node" />
import { IListArgs, IObject, IStorageService, IStorageServiceCopyArgs, IStorageServiceGetMetadataResult, IStorageServiceSetMetadataArgs, IUploadArgs } from './IStorageService';
import ReadableStream = NodeJS.ReadableStream;
export interface IS3Settings {
    accessKeyID: string;
    secretAccessKey: string;
    region: string;
    bucket: string;
}
export declare class S3 implements IStorageService {
    private readonly s3;
    private readonly bucket;
    constructor(settings: IS3Settings);
    copy({ fromKey, toKey, contentType, metadata, }: IStorageServiceCopyArgs): Promise<void>;
    getMetadata(key: string): Promise<IStorageServiceGetMetadataResult>;
    setMetadata({ key, metadata }: IStorageServiceSetMetadataArgs): Promise<void>;
    list({ prefix, maximumKeys }: IListArgs): Promise<IObject[]>;
    delete(...keys: string[]): Promise<void>;
    upload({ key, data, contentType, metadata }: IUploadArgs): Promise<void>;
    stream(key: string): ReadableStream;
}
