"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const fs_jogger_1 = require("fs-jogger");
const path = __importStar(require("path"));
const hashStream_1 = require("../Utils/hashStream");
const common_1 = require("./common");
exports.getLocalHashes = ({ directory, }) => __awaiter(void 0, void 0, void 0, function* () {
    const files = yield fs_jogger_1.jogList({ dir: directory });
    const hashes = yield Promise.all(files.map(f => hashStream_1.hashStream(common_1.HASH_TYPE, fs.createReadStream(path.join(directory, f)))));
    return new Map(files.map((f, i) => [common_1.normaliseFilePath(f), hashes[i]]));
});
