"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const crypto = __importStar(require("crypto"));
exports.hashStream = (hashType, stream) => {
    return new Promise((resolve, reject) => {
        const hash = crypto.createHash(hashType);
        let sha512;
        hash.on('readable', () => {
            // Only one element is produced by the hash stream.
            // See https://nodejs.org/api/crypto.html#crypto_class_hash for more details.
            const data = hash.read();
            if (data) {
                sha512 = data.toString('hex');
            }
        });
        hash.on('finish', () => {
            if (sha512 === undefined) {
                throw new Error('Hash was not generated');
            }
            resolve(sha512);
        });
        hash.on('error', err => reject(err));
        stream.pipe(hash);
    });
};
